<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
    <v-layout align-center justify-center>
        <v-card max-width="90%">
            <v-card-title>
                <v-layout column>

                    <v-btn
                            color="green"
                            dark
                            small
                            absolute
                            top
                            left
                            fab
                            @click="add"
                    >
                        <v-icon light>add</v-icon>
                    </v-btn>
                    <v-data-table
                            :headers="headers"
                            :items="allData"
                            hide-actions
                    >
                        <template
                                slot="headerCell"
                                slot-scope="{ header }"
                        >
                    <span class="subheading font-weight-light text-success text--darken-3"
                          v-text="header.text"
                    ></span>

                        </template>
                        <template v-slot:no-data>
                            <div v-show="allDataLoading === true" class="justify-center layout px-0">
                                <v-progress-circular indeterminate color="primary"
                                                     align-center justify-center row></v-progress-circular>
                            </div>

                            <div v-show="allData.length === 0 && allDataLoading === false"
                                 class="justify-center layout px-0">
                                {{'داده ای وجود ندارد'}}
                            </div>

                        </template>
                        <template
                                slot="items"
                                slot-scope="{ item }"
                        >
                            <td>{{ item.first_name}}</td>
                            <td>{{ item.last_name}}</td>
                            <td>{{ item.email}}</td>
                            <td>{{ item.role.name}}</td>

                            <td class="justify-center layout px-0">
                                <v-icon
                                        small
                                        class="mr-2"
                                        @click="edit(item)"
                                >
                                    edit
                                </v-icon>

                                <v-icon
                                        small
                                        @click="deleteItem(item)"
                                >
                                    delete
                                </v-icon>
                            </td>
                        </template>
                    </v-data-table>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-dialog v-model="AddDialog" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-form
                                ref="form"
                                v-model="valid"
                                lazy-validation
                        >

                            <v-layout wrap>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="nameRules" @change="setFirstName" v-model="selectedItem.first_name"
                                                  label="نام"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="nameRules" @change="setLastName" v-model="selectedItem.last_name"
                                                  label="نام خانوادگی"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field @change="setEmail" v-model="selectedItem.email"
                                                  label="ایمیل"></v-text-field>
                                </v-flex>

                                <v-flex xs12 sm4 md4>
                                    <v-select
                                            :rules="roleRules"
                                            v-model="selectedItem.role.name"
                                            :items="AllRole"
                                            item-text="name"
                                            outlined
                                            label="نقش اپراتور را انتخاب کنید"
                                            single-line
                                            @change="setRole"
                                            return-object
                                    ></v-select>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field @change="setPassword" label="رمز عبور جدید"></v-text-field>
                                </v-flex>
                            </v-layout>
                        </v-form>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideAddDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="add_Edit">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">ذخیره</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="DeleteDialog"
                width="500"
        >

            <v-card>
                <v-card-text>
                    آیا مطمئن هستید که می خواهید این اپراتور را حذف کنید؟
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideDeleteDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="deleteOne">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">حذف</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-layout>
</template>
<script>
    import {mapActions, mapMutations, mapState} from "vuex";

    export default {
        name: "operator",
        methods: {
            ...mapMutations({
                setFirstName: 'operator/setFirstName',
                setLastName: 'operator/setLastName',
                setEmail: 'operator/setEmail',
                setRole: 'operator/setRole',
                setPassword: 'operator/setPassword',
                setSelectedItem: 'operator/setSelectedItem',
                showAddDialog: 'operator/showAddDialog',
                hideAddDialog: 'operator/hideAddDialog',
                showDeleteDialog: 'operator/showDeleteDialog',
                hideDeleteDialog: 'operator/hideDeleteDialog'
            }),
            ...mapActions({
                readData: 'operator/readData',
                addOrEdit: 'operator/addOrEdit',
                deleteOne: 'operator/deleteOne'
            }),

            add() {
                this.setSelectedItem({
                    id: null,
                    first_name: null,
                    last_name: null,
                    email: null,
                    password: null,
                    status: null,
                    role: {id: null, name: null}
                });
                this.showAddDialog();
            },
            edit(item) {
                this.setSelectedItem({
                    id: item.id,
                    first_name: item.first_name,
                    last_name: item.last_name,
                    email: item.email,
                    password: item.password,
                    status: item.status,
                    role: {id: item.role.id, name: item.role.name}
                });
                this.showAddDialog();
            },
            add_Edit() {
                if (this.$refs.form.validate()) {
                    this.addOrEdit();
                }
            },

            deleteItem(item) {
                this.setSelectedItem(item);
                this.showDeleteDialog()
            },
        },
        computed: {
            ...mapState({
                allData: state => state.operator.allData,
                AllRole: state => state.operator.AllRole,
                AddDialog: state => state.operator.AddDialog,
                DeleteDialog: state => state.operator.DeleteDialog,
                selectedItem: state => state.operator.selectedItem,
                pending: state => state.operator.pending,
                allDataLoading: state => state.operator.allDataLoading,
            })
        },
        mounted() {
            this.readData();
        },
        data() {
            return {
                valid: true,
                nameRules: [
                    v => !!v || 'این فیلد نمیتواند خالی باشد',
                    v => (!v || v.length >= 2) || 'حداقل باید 4 کاراکتر بنویسید',
                ],
                roleRules: [
                    v => !!v || 'این فیلد نمیتواند خالی باشد',
                ],
                headers: [
                    {text: 'نام', align: 'right', value: 'first_name'},
                    {text: 'نام خانوادگی', align: 'right', value: 'last_name'},
                    {text: 'ایمیل', align: 'right', value: 'email'},
                    {text: 'نقش', align: 'right', value: 'role.name'},

                ],
            }
        },
    }
</script>
<style scoped>
</style>